<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>Z:/Project/development/PSCIP/driver/test.c Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
<link href="tabs.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.7.1 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
<h1>Z:/Project/development/PSCIP/driver/test.c</h1><a href="test_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> *</span>
<a name="l00003"></a>00003 <span class="comment"> * test.c: use async notification to read stdin</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> *  22/10/2008 - Start of porting the driver :</span>
<a name="l00006"></a>00006 <span class="comment"> * - from 2.4.x to 2.6.x</span>
<a name="l00007"></a>00007 <span class="comment"> * -  from VME to PCIGG </span>
<a name="l00008"></a>00008 <span class="comment"> * </span>
<a name="l00009"></a>00009 <span class="comment"> */</span>
<a name="l00010"></a>00010 <span class="preprocessor">#include &lt;sys/types.h&gt;</span>
<a name="l00011"></a>00011 <span class="preprocessor">#include &lt;sys/stat.h&gt;</span>
<a name="l00012"></a>00012 <span class="preprocessor">#include &lt;sys/time.h&gt;</span>
<a name="l00013"></a>00013 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00014"></a>00014 <span class="preprocessor">#include &lt;stdlib.h&gt;</span>
<a name="l00015"></a>00015 <span class="preprocessor">#include &lt;unistd.h&gt;</span>
<a name="l00016"></a>00016 <span class="preprocessor">#include &lt;signal.h&gt;</span>
<a name="l00017"></a>00017 <span class="preprocessor">#include &lt;fcntl.h&gt;</span>
<a name="l00018"></a>00018 <span class="preprocessor">#include &lt;sys/ioctl.h&gt;</span>
<a name="l00019"></a>00019 <span class="preprocessor">#include "<a class="code" href="pscip_8h.html" title="Header file used in the driver and device server.">pscip.h</a>"</span>
<a name="l00020"></a>00020 <span class="comment">/*</span>
<a name="l00021"></a>00021 <span class="comment">options</span>
<a name="l00022"></a>00022 <span class="comment"></span>
<a name="l00023"></a>00023 <span class="comment"> exec name | letter  | number </span>
<a name="l00024"></a>00024 <span class="comment">   t   any  ---&gt; resets both IPs,      calles k_pscip_reset()</span>
<a name="l00025"></a>00025 <span class="comment">   r   any  ---&gt; reading in loop from local_space_1 - do not work</span>
<a name="l00026"></a>00026 <span class="comment">   w   any  ---&gt; nothing</span>
<a name="l00027"></a>00027 <span class="comment">   h   1  ---&gt; resets IP A        calles IP_reset(pmap_address, 1);</span>
<a name="l00028"></a>00028 <span class="comment">   h   2  ---&gt; resets IP B        calles IP_reset(pmap_address, 2);</span>
<a name="l00029"></a>00029 <span class="comment">   h   3  ---&gt; writes to IP A "high prioroty write"   IP_write(volatile struct IPregister *pReg, u8 status, u8 address, u32 data)</span>
<a name="l00030"></a>00030 <span class="comment">   h   4  ---&gt; writes to IP B "high prioroty write"   IP_write(volatile struct IPregister *pReg, u8 status, u8 address, u32 data)</span>
<a name="l00031"></a>00031 <span class="comment">   h   5  ---&gt; writes to IP A "high prioroty write"   IP_write_2(volatile struct IPstruct *pReg, u8 status, u8 address, u32 data)</span>
<a name="l00032"></a>00032 <span class="comment">   h   6  ---&gt; writes to IP B "high prioroty write"   IP_write_2(volatile struct IPstruct *pReg, u8 status, u8 address, u32 data)</span>
<a name="l00033"></a>00033 <span class="comment">   h   7  ---&gt; reads from PFGA stat. reg, stat reg and interrupt reg IP_read_1(volatile struct IPstruct *pIP) -&gt; mapping entire I/O, blank spaces included</span>
<a name="l00034"></a>00034 <span class="comment">   h   8  ---&gt; reads from PFGA stat. reg, stat reg and interrupt reg IP_read_2(volatile struct IPstruct *pIP) -&gt; mapping ONLY local space  blank spaces included   </span>
<a name="l00035"></a>00035 <span class="comment">   h   9  ---&gt; reads from PFGA stat. reg, stat reg and interrupt reg IP_read_3(volatile struct IPstruct *pIP) -&gt; mapping ONLY local space, no blank spacee      </span>
<a name="l00036"></a>00036 <span class="comment">   h   10  ---&gt; reads from PFGA stat. reg, stat reg and interrupt reg IP_read_4(v) -&gt; reading by shifting pointer and using inw() - rather not work    </span>
<a name="l00037"></a>00037 <span class="comment">   h   11  ---&gt; reads from PFGA stat. reg, stat reg and interrupt reg IP_read_5(v) -&gt; reading by shifting pointer to the IPregister struct </span>
<a name="l00038"></a>00038 <span class="comment">*/</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="test_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">00042</a> <a class="code" href="structpscip__t.html">pscip_t</a> <a class="code" href="test_8c.html#034d0a6e2de0ba1b729fc54e5ec15f04">val</a>;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a><a class="code" href="test_8c.html#0ddf1224851353fc92bfbff6f499fa97">00045</a> <span class="keywordtype">int</span> <a class="code" href="test_8c.html#0ddf1224851353fc92bfbff6f499fa97">main</a>(<span class="keywordtype">int</span> argc, <span class="keywordtype">char</span> *argv[])
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047  <span class="keywordtype">int</span> fd, err;
<a name="l00048"></a>00048  <a class="code" href="structpscip__t.html">pscip_t</a> val;
<a name="l00049"></a>00049  <span class="keywordtype">int</span> cmd;
<a name="l00050"></a>00050  
<a name="l00051"></a>00051 
<a name="l00052"></a>00052  
<a name="l00053"></a>00053  <span class="keywordflow">if</span> ((fd = open(<span class="stringliteral">"/dev/pscip"</span>, O_RDWR)) &lt; 0) 
<a name="l00054"></a>00054  {
<a name="l00055"></a>00055   printf(<span class="stringliteral">"Cannot open \n"</span>);
<a name="l00056"></a>00056   <span class="keywordflow">return</span> 0;
<a name="l00057"></a>00057  } 
<a name="l00058"></a>00058  
<a name="l00059"></a>00059  printf(<span class="stringliteral">"cmd: %c, val.chan: %d\n"</span>,argv[1][0],atoi(argv[2]));
<a name="l00060"></a>00060  
<a name="l00061"></a>00061  <span class="keywordflow">if</span> (argv[1][0] == <span class="charliteral">'r'</span>) 
<a name="l00062"></a>00062  {
<a name="l00063"></a>00063   
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   
<a name="l00066"></a>00066   val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);
<a name="l00067"></a>00067   val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0x0; <span class="comment">// reading status register </span>
<a name="l00068"></a>00068   
<a name="l00069"></a>00069   val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = 0x12;
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="keywordflow">if</span> ((err = ioctl(fd, <a class="code" href="pscip_8h.html#1ad87f3dd3daf9ceac34bc7c040fd488">PSCIP_READ</a>, &amp;val))) {
<a name="l00072"></a>00072    printf(<span class="stringliteral">"Ioctl error:in read\n"</span>);
<a name="l00073"></a>00073    <span class="keywordflow">return</span> 0;
<a name="l00074"></a>00074   } 
<a name="l00075"></a>00075   printf(<span class="stringliteral">"ioctl() performed"</span>);
<a name="l00076"></a>00076   
<a name="l00077"></a>00077   
<a name="l00078"></a>00078  }
<a name="l00079"></a>00079  <span class="keywordflow">else</span> <span class="keywordflow">if</span> (argv[1][0] == <span class="charliteral">'w'</span>) 
<a name="l00080"></a>00080  { 
<a name="l00081"></a>00081   val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);  
<a name="l00082"></a>00082   
<a name="l00083"></a>00083   <span class="comment">//sscanf(argv[7], "%3x", &amp;tmp);</span>
<a name="l00084"></a>00084   <span class="comment">//val.stat = tmp;</span>
<a name="l00085"></a>00085   val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0x80; <span class="comment">// writing status register </span>
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   
<a name="l00088"></a>00088   val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = 0x12; 
<a name="l00089"></a>00089   
<a name="l00090"></a>00090  
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="keywordflow">if</span> (err = ioctl(fd,  <a class="code" href="pscip_8h.html#145abb0528d0562f2d3e9180d2d8bdd7">PSCIP_WRITE</a>, &amp;val)) { <span class="comment">// PSCIP_WRITE , PSCIP_WRHIPRIO </span>
<a name="l00093"></a>00093    printf(<span class="stringliteral">"Ioctl error ii write:\n"</span>);
<a name="l00094"></a>00094    <span class="keywordflow">return</span> 0;
<a name="l00095"></a>00095   } 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097  }
<a name="l00098"></a>00098  <span class="keywordflow">else</span> <span class="keywordflow">if</span> (argv[1][0] == <span class="charliteral">'t'</span>) 
<a name="l00099"></a>00099  { 
<a name="l00100"></a>00100   val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);  
<a name="l00101"></a>00101   
<a name="l00102"></a>00102   <span class="comment">//sscanf(argv[7], "%3x", &amp;tmp);</span>
<a name="l00103"></a>00103   <span class="comment">//val.stat = tmp;</span>
<a name="l00104"></a>00104   val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0x80; <span class="comment">// writing status register </span>
<a name="l00105"></a>00105   
<a name="l00106"></a>00106   
<a name="l00107"></a>00107   val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = 0x12; 
<a name="l00108"></a>00108   
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="keywordflow">if</span> (err = ioctl(fd,  <a class="code" href="pscip_8h.html#5788cb36fa2a76b191152affbce54791">PSCIP_RESET</a>)) 
<a name="l00111"></a>00111   { <span class="comment">// PSCIP_WRITE , PSCIP_WRHIPRIO </span>
<a name="l00112"></a>00112    printf(<span class="stringliteral">"Ioctl error ii reset:\n"</span>);
<a name="l00113"></a>00113    <span class="keywordflow">return</span> 0;
<a name="l00114"></a>00114   } 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116  }
<a name="l00117"></a>00117  <span class="keywordflow">else</span> <span class="keywordflow">if</span> (argv[1][0] == <span class="charliteral">'h'</span>) 
<a name="l00118"></a>00118  { 
<a name="l00119"></a>00119   val.<a class="code" href="structpscip__t.html#8ee0b97dd5e2ac9fc6fbfaf5cdf0fba7">chan</a> = atoi(argv[2]);  
<a name="l00120"></a>00120   
<a name="l00121"></a>00121   <span class="comment">//sscanf(argv[7], "%3x", &amp;tmp);</span>
<a name="l00122"></a>00122   <span class="comment">//val.stat = tmp;</span>
<a name="l00123"></a>00123   val.<a class="code" href="structpscip__t.html#79235a96d6d6c52c0bb0dcc922947547">stat</a> = 0x80; <span class="comment">// writing status register </span>
<a name="l00124"></a>00124   
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   val.<a class="code" href="structpscip__t.html#01955693eb0a6d5a3faae4585887f9e3">address</a> = 0x12; 
<a name="l00127"></a>00127   
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="keywordflow">if</span> (err = ioctl(fd,  <a class="code" href="pscip_8h.html#f564936bc290fbdda24a3f9ce25ea70d">PSCIP_WRHIPRIO</a>, &amp;val)) 
<a name="l00130"></a>00130   { <span class="comment">// PSCIP_WRITE , PSCIP_WRHIPRIO </span>
<a name="l00131"></a>00131    printf(<span class="stringliteral">"Ioctl error ii reset:\n"</span>);
<a name="l00132"></a>00132    <span class="keywordflow">return</span> 0;
<a name="l00133"></a>00133   } 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135  }
<a name="l00136"></a>00136  <span class="keywordflow">else</span> {
<a name="l00137"></a>00137   printf(<span class="stringliteral">"Error: invalid action type (r/w/a/t)\n"</span>);
<a name="l00138"></a>00138   <span class="keywordflow">return</span> 0;
<a name="l00139"></a>00139  }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141  close(fd);
<a name="l00142"></a>00142  <span class="keywordflow">return</span> 0;
<a name="l00143"></a>00143   
<a name="l00144"></a>00144 }
</pre></div></div>
<hr size="1"><address style="text-align: right;"><small>Generated on Fri Dec 5 17:49:43 2008 by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.5.7.1 </small></address>
</body>
</html>
